package com.ruoyi.web.yh.price.domain;

import java.math.BigDecimal;
import java.time.LocalDateTime;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.validate.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * 单价对象 bst_price
 *
 * @author ruoyi
 * @date 2024-10-17
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class Price extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long priceId;

    @Excel(name = "部门ID")
    @ApiModelProperty("部门ID")
    @NotNull(message = "部门不允许为空", groups = ValidGroup.Create.class)
    private Long deptId;

    @Excel(name = "状态")
    @ApiModelProperty("状态")
    private String status;

    @Excel(name = "类别")
    @ApiModelProperty("类别")
    @Size(max = 200, message = "类别不允许超过200个字符")
    private String category;

    @Excel(name = "大小")
    @ApiModelProperty("大小")
    @Size(max = 200, message = "大小不允许超过200个字符")
    private String size;

    @Excel(name = "工序名称")
    @ApiModelProperty("工序名称")
    @Size(max = 200, message = "工序名称不允许超过200个字符")
    private String name;

    @Excel(name = "子工序名称")
    @ApiModelProperty("子工序名称")
    @Size(max = 200, message = "子工序名称不允许超过200个字符")
    private String subName;

    @Excel(name = "图案")
    @ApiModelProperty("图案")
    @Size(max = 200, message = "图案不允许超过200个字符")
    private String pattern;

    @Excel(name = "规格")
    @ApiModelProperty("规格")
    @Size(max = 200, message = "规格不允许超过200个字符")
    private String spec;

    @Excel(name = "单价")
    @ApiModelProperty("单价")
    @NotNull(message = "单价不允许为空", groups = ValidGroup.Create.class)
    @Min(value = 0, message = "单价不允许小于0元")
    private BigDecimal price;

    @Excel(name = "单位")
    @ApiModelProperty("单位")
    @Size(max = 50, message = "单位不允许超过50个字符")
    private String unit;

    @Excel(name = "分类")
    @ApiModelProperty("分类")
    @Size(max = 200, message = "分类不允许超过200个字符")
    private String classify;

    @Excel(name = "创建人ID")
    @ApiModelProperty("创建人ID")
    private Long createId;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "审核时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("审核时间")
    private LocalDateTime verifyTime;

    @Excel(name = "审核人ID")
    @ApiModelProperty("审核人ID")
    private Long verifyId;

    @Excel(name = "审核人名称")
    @ApiModelProperty("审核人名称")
    private String verifyBy;

    @Excel(name = "更新人ID")
    @ApiModelProperty("更新人ID")
    private Long updateId;

    @Excel(name = "是否禁用")
    @ApiModelProperty("是否禁用")
    private Boolean disabled;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "禁用时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("禁用时间")
    private LocalDateTime disabledTime;

    @Excel(name = "生产数量(个)")
    @ApiModelProperty("生产数量(个)")
    @Min(value = 0, message = "生产数量不允许小于0个")
    private BigDecimal quantity;

}
